use serde::{Deserialize, Serialize};

// TODO: Serialize as array of [red, green, blue] in NBT
#[derive(Debug, Clone, Copy, Serialize, Deserialize)]
pub struct RGBf32 {
    red: f32,
    green: f32,
    blue: f32,
}

// TODO: Serialize as array of [red, green, blue, alpha] in NBT
#[derive(Debug, Clone, Copy, Serialize, Deserialize)]
pub struct RGBAf32 {
    red: f32,
    green: f32,
    blue: f32,
    alpha: f32,
}

// TODO: Serialize as u32 of red<<16+green<<8+blue in NBT
#[derive(Debug, Clone, Copy, Serialize, Deserialize)]
pub struct RGBu8 {
    red: u8,
    green: u8,
    blue: u8,
}

// TODO: Serialize as u32 of alpha<<24+red<<16+green<<8+blue in NBT
#[derive(Debug, Clone, Copy, Serialize, Deserialize)]
pub struct ARGBu8 {
    alpha: u8,
    red: u8,
    green: u8,
    blue: u8,
}
