use potato_protocol_derive::Packet;
use serde::{Deserialize, Serialize};

use crate::packet_encodable::Json;

#[derive(Packet, Debug)]
#[packet(status_id = crate::ids::status::clientbound::STATUS_RESPONSE)]
pub struct StatusResponsePacket {
    pub status: Json<StatusResponseData>,
}

#[derive(Serialize, Deserialize, Debug)]
pub struct StatusResponseData {
    pub version: Version,
    pub players: Players,
    pub description: Description,
    pub favicon: Option<String>,
    pub enforce_secure_chat: bool,
}

#[derive(Serialize, Deserialize, Debug)]
pub struct Version {
    pub name: String,
    pub protocol: i32,
}

#[derive(Serialize, Deserialize, Debug)]
pub struct Players {
    pub max: i32,
    pub online: i32,
    pub sample: Vec<Player>,
}

#[derive(Serialize, Deserialize, Debug)]
pub struct Player {
    pub name: String,
    pub id: String,
}

#[derive(Serialize, Deserialize, Debug)]
pub struct Description {
    pub text: String,
}
